/// <reference types="bluebird" />
/// <reference types="sequelize" />
import * as Bluebird from 'bluebird';
import * as Sequelize from 'sequelize';
import { Query, SynchronizerItem } from 'pretur.sync';
import { ResolveResult } from './resolver';
import { ModelDescriptor } from './descriptor';
import { ResultItemAppender } from './synchronizer';
export interface ModelDescriptorMap {
    [model: string]: ModelDescriptor<any>;
}
export interface Pool {
    models: ModelDescriptorMap;
    resolve(query: Query, context: any): Bluebird<ResolveResult<any>>;
    sync(transaction: Sequelize.Transaction, item: SynchronizerItem<any>, rip: ResultItemAppender, context: any): Bluebird<void>;
}
export declare function createPool(...descriptors: ModelDescriptor<any>[]): Pool;
